<ion-header>
    <ion-navbar color="innova">
        <button ion-button menuToggle>
        <ion-icon name="menu" class="custom-menu-color"></ion-icon>
        </button>
        <ion-title><img src="assets/imgs/logo-cliente.png" class="custom-logo-position"><span class="custom-title-color">Planificación</span></ion-title>
        <div class="div-bell-custom-size">
        <svg aria-hidden="true" focusable="false" data-prefix="fas" data-icon="bell" class="svg-inline--fa fa-bell fa-w-14 icon-bell-custom-size" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><path fill="currentColor" d="M224 512c35.32 0 63.97-28.65 63.97-64H160.03c0 35.35 28.65 64 63.97 64zm215.39-149.71c-19.32-20.76-55.47-51.99-55.47-154.29 0-77.7-54.48-139.9-127.94-155.16V32c0-17.67-14.32-32-31.98-32s-31.98 14.33-31.98 32v20.84C118.56 68.1 64.08 130.3 64.08 208c0 102.3-36.15 133.53-55.47 154.29-6 6.45-8.66 14.16-8.61 21.71.11 16.4 12.98 32 32.1 32h383.8c19.12 0 32-15.6 32.1-32 .05-7.55-2.61-15.27-8.61-21.71z"></path></svg>        
        </div>
    </ion-navbar>
</ion-header>

<ion-content>
    <ng-container *ngIf="dataDidLoad">
        <ion-list style="margin-bottom: 0 !important;">
            <form [formGroup]="myForm" novalidate style="height: 100%;">
                <div style="margin-left: 17px; color: #7c8080;"><h1>Nueva planificación</h1></div>
                <div style="padding: 10px">
                <ion-item>
                    <ion-label floating>Nombre de la planificación</ion-label>
                    <ion-input  formControlName="description" type="text">
                    </ion-input>
                </ion-item>
                <ion-item class="p-obra" *ngIf="myForm.get('description').errors && myForm.get('description').touched">
                    <p class="p-obra" color="danger" ion-text *ngIf="myForm.get('description').hasError('required')">Debe ingresar el nombre de la planificación</p>
                </ion-item>

                <ng-container *ngIf="userInfo.enterprise_id == 2">
                    <ion-item style="margin-top: 30px">
                        <ion-label>Empresa</ion-label>
                        <ionic-selectable
                        item-content
                        formControlName="enterprise"
                        [items]="enterprises"
                        itemValueField="id"
                        itemTextField="name"
                        [canSearch]="true"
                        (onChange)="enterpriseSelected($event)"
                        searchFailText="No se encontraron resultados">
                        </ionic-selectable>
                    </ion-item>
                    <ion-item class="p-obra" *ngIf="myForm.get('enterprise').touched && myForm.get('enterprise').hasError('required')">
                        <p class="p-obra" color="danger" ion-text>Debe seleccionar una empresa</p>
                    </ion-item>
                </ng-container>

                <ion-item style="margin-top: 30px">
                    <ion-label>Obra</ion-label>
                    <ionic-selectable
                    [isEnabled]="enterpriseIsSet"
                    item-content
                    formControlName="construction_id"
                    [items]="constructions_confirmed"
                    itemValueField="id"
                    itemTextField="description"
                    [canSearch]="true"
                    searchFailText="No se encontraron resultados">
                    </ionic-selectable>
                </ion-item>
                <ion-item class="p-obra" *ngIf="myForm.get('construction_id').touched && myForm.get('construction_id').hasError('required')">
                    <p class="p-obra" color="danger" ion-text>Debe seleccionar una obra</p>
                </ion-item>

                <ion-item style="margin-top: 30px">
                    <ion-label>Protocolo</ion-label>
                    <ion-select interface="popover" formControlName="protocol_id" cancelText="Cancelar" okText="Aceptar">
                        <ion-option *ngFor="let item of protocols" [value]="item" >{{item.name}}</ion-option>
                    </ion-select>
                </ion-item>
                <ion-item class="p-obra" *ngIf="myForm.get('protocol_id').touched && myForm.get('protocol_id').hasError('required')">
                    <p class="p-obra" color="danger" ion-text>Debe seleccionar un protocolo</p>
                </ion-item>

                <ion-grid>
                    <ion-row>
                        <ion-col>
                            <ion-item  class="item item-trns text-center">
                                <ion-label floating>Fecha de inicio</ion-label>
                                <ion-datetime  [min]="minDate" [max]="maxDate" displayFormat="YYYY-MM-DD" formControlName="start_date" cancelText="Cancelar" doneText="Hecho"></ion-datetime>
                            </ion-item>
                        </ion-col>
                        <ion-col>
                            <ion-item  class="item item-trns text-center">
                                <ion-label floating>Hora de inicio</ion-label>
                                <ion-datetime  displayFormat="HH:mm" pickerFormat="HH : mm" cancelText="Cancelar" doneText="Hecho" formControlName="start_hour"></ion-datetime>
                            </ion-item>
                        </ion-col>
                    </ion-row>
                </ion-grid>

                <!-- <ion-item  class="item item-trns text-center">
                    <ion-label floating>Fecha de inicio</ion-label>
                    <ion-datetime [min]="minDate" [max]="maxDate" displayFormat="YYYY-MM-DD" formControlName="start_date" cancelText="Cancelar" doneText="Hecho"></ion-datetime>
                    <ion-label floating>Hora de inicio</ion-label>
                    <ion-datetime displayFormat="HH:mm" cancelText="Cancelar" doneText="Hecho" formControlName="start_hour"></ion-datetime>
                </ion-item> -->
                <ion-item class="p-obra" *ngIf="(myForm.get('start_date').touched && (myForm.get('start_date').hasError('required') || !validTime.validDates)) || (myForm.get('start_hour').touched && (myForm.get('start_hour').hasError('required') || !validTime.validHour))">
                    <p class="p-obra" color="danger" ion-text *ngIf="myForm.get('start_date').hasError('required') && myForm.get('start_date').touched">Debe ingresar una fecha de inicio <br></p>
                    <p class="p-obra" color="danger" ion-text *ngIf="!validTime.validDates">Fecha debe ser menor a la de cierre <br></p>
                    <p class="p-obra" color="danger" ion-text *ngIf="myForm.get('start_hour').hasError('required') && myForm.get('start_hour').touched">Debe ingresar una hora de inicio <br></p>
                    <p class="p-obra" color="danger" ion-text *ngIf="!validTime.validHour">Hora debe ser menor a la de cierre</p>
                </ion-item>

                <!-- <ion-item  class="item item-trns text-center">
                    <ion-label floating>Hora de inicio</ion-label>
                    <ion-datetime displayFormat="HH:mm" cancelText="Cancelar" doneText="Hecho" formControlName="start_hour"></ion-datetime>
                </ion-item>
                <ion-item class="p-obra" *ngIf="myForm.get('start_hour').touched && (myForm.get('start_hour').hasError('required') || !validTime.validHour)">
                    <p class="p-obra" color="danger" ion-text *ngIf="myForm.get('start_hour').hasError('required')">Debe ingresar una hora de inicio</p>
                    <p class="p-obra" color="danger" ion-text *ngIf="!validTime.validHour">Esta hora debe ser menor a la de cierre</p>
                </ion-item> -->

                <ion-grid>
                    <ion-row>
                        <ion-col>
                            <ion-item  class="item item-trns text-center">
                                <ion-label floating>Fecha de cierre</ion-label>
                                <ion-datetime  [min]="minDate" [max]="maxDate" displayFormat="YYYY-MM-DD" cancelText="Cancelar" doneText="Hecho" formControlName="end_date"></ion-datetime>
                            </ion-item>
                        </ion-col>
                        <ion-col>
                            <ion-item  class="item item-trns text-center">
                                <ion-label floating>Hora de cierre</ion-label>
                                <ion-datetime  displayFormat="HH:mm" pickerFormat="HH : mm" cancelText="Cancelar" doneText="Hecho" formControlName="end_hour"></ion-datetime>
                            </ion-item>
                        </ion-col>
                    </ion-row>
                </ion-grid>
                <ion-item class="p-obra" *ngIf="(myForm.get('end_date').touched && (myForm.get('end_date').hasError('required') || !validTime.validDates)) || (myForm.get('end_hour').touched && (myForm.get('end_hour').hasError('required') || !validTime.validHour))">
                    <p class="p-obra" color="danger" ion-text *ngIf="myForm.get('end_date').hasError('required') && myForm.get('end_date').touched">Debe ingresar una fecha de cierre<br></p>
                    <p class="p-obra" color="danger" ion-text *ngIf="!validTime.validDates">Fecha debe ser mayor a la de inicio<br></p>
                    <p class="p-obra" color="danger" ion-text *ngIf="myForm.get('end_hour').hasError('required') && myForm.get('end_hour').touched">Debe ingresar una hora de cierre<br></p>
                    <p class="p-obra" color="danger" ion-text *ngIf="!validTime.validHour">Hora debe ser mayor a la de inicio</p>
                </ion-item>

                <!-- <ion-item class="item item-trns text-center">
                    <ion-label floating>Fecha de cierre</ion-label>
                    <ion-datetime [min]="minDate" [max]="maxDate" displayFormat="YYYY-MM-DD" cancelText="Cancelar" doneText="Hecho" formControlName="end_date"></ion-datetime>
                </ion-item>
                <ion-item class="p-obra" *ngIf="myForm.get('end_date').touched && (myForm.get('end_date').hasError('required') || !validTime.validDates)">
                    <p class="p-obra" color="danger" ion-text *ngIf="myForm.get('end_date').hasError('required')">Debe ingresar una fecha de cierre</p>
                    <p class="p-obra" color="danger" ion-text *ngIf="!validTime.validDates">Fecha debe ser mayor a la de inicio</p>
                </ion-item>

                <ion-item  class="item item-trns text-center">
                    <ion-label floating>Hora de cierre</ion-label>
                    <ion-datetime displayFormat="HH:mm" cancelText="Cancelar" doneText="Hecho" formControlName="end_hour"></ion-datetime>
                </ion-item>
                <ion-item class="p-obra" *ngIf="myForm.get('end_hour').touched && (myForm.get('end_hour').hasError('required') || !validTime.validHour)">
                    <p class="p-obra" color="danger" ion-text *ngIf="myForm.get('end_hour').hasError('required')">Debe ingresar una hora de cierre</p>
                    <p class="p-obra" color="danger" ion-text *ngIf="!validTime.validHour">Hora debe ser mayor a la de inicio</p>
                </ion-item> -->
                <ion-item style="margin-top: 30px">
                    <ion-label>Rol supervisor a cargo</ion-label>
                    <ion-select interface="popover" formControlName="supervisor" (ionChange)="removeSupervisor()">
                        <ion-option *ngFor="let rol of supervisorRoles" [value]="rol" >{{rol.name}}</ion-option>
                    </ion-select>
                </ion-item>        
                </div>
            </form>

            <!-- <ion-item style="margin-top: 30px">
                <ion-label>Rol supervisor a cargo</ion-label>
                <ion-select interface="popover" [(ngModel)]="rolSupervisorSelected" (ionChange)="removeSupervisor()">
                    <ion-option *ngFor="let rol of supervisorRoles" [value]="rol" >{{rol.name}}</ion-option>
                </ion-select>
            </ion-item>  -->

            <div style="margin-top: 30px; margin-bottom: 30px">
                <ion-label style="margin-left: 25px; color: #9b9b9b; font-size: 16px;">Participantes</ion-label>
                <hr style="width: 95%; height: 1.25px;">

                <ion-item style="margin-top: 10px">
                    <ion-label>Rol de participante</ion-label>
                    <ion-select [disabled]="!peoplesIsSet || !participantsIsSet" interface="popover" [(ngModel)]="rolSelected" (ionChange)="searchNames()">
                        <ion-option *ngFor="let rol of participants.roles" [value]="rol" >{{rol.name}}</ion-option>
                    </ion-select>
                </ion-item>

                <ion-item style="margin-top: 10px">
                    <ion-label>Seleccione participante</ion-label>
                    <ionic-selectable
                    [isEnabled]="peoplesIsSet && participantsIsSet"
                    debounce="0"
                    item-content
                    [(ngModel)]="participantSelected"
                    [items]="participants.names"
                    itemValueField="id"
                    itemTextField="name"
                    [canSearch]="true"
                    (onSelect)="onSelect($event)"
                    (onClose)="onClose($event)"
                    searchFailText="No se encontraron resultados"
                    #selectSearchComponent>
                    </ionic-selectable>
                </ion-item>

                <ng-container *ngFor="let people_selected of peoples_selected">
                    <ion-card (click)="removeSelected(people_selected)">
                        <ion-item class="people-selected">
                            {{ people_selected.name }} <br> {{ people_selected.selected_peopleType.name }}
                            <ion-icon style="color: white;" name="close" item-end></ion-icon>
                        </ion-item>
                    </ion-card>
                </ng-container>

            </div>

            <div class="footer">
                <button ion-button style="width: 100%; background-color: #009ee3; color: #ffffff" [disabled]="myForm.invalid || !validTime.validDates || !validTime.validHour" (click)="savePlanification()">Crear</button>
            </div>
        </ion-list>
    </ng-container>
</ion-content>